
#include <IRremote.h>
#include <RTClib.h>
#include <Wire.h>
RTC_DS1307 rtc;
int RECV_PIN = 3;
IRrecv irrecv(RECV_PIN);
decode_results results;
int value[36];
int digit[]= {2222,2224,2226,2228,2242,2244,2246,2248,2262,2264,6228,2622,2624}; 
          //  dig0,dig1,dig2,dig3,dig4,dig5,dig6,dig7,dig8,dig9,back,ch_up,ch_dn
int x,keycode,LEDPIN=8; // LED pin will trigger when IR remote is pressed
unsigned long t; // to store millis

#include <SPI.h>
#include <SD.h>
File myFile;

void setup()
{ 
  
  pinMode(LEDPIN,OUTPUT); // declare the LED pin as aoutput
  digitalWrite(LEDPIN,LOW); // make led off initially
  irrecv.enableIRIn(); // IR module ready
  initilize_rtc(); // RTC initialize
  DateTime now = rtc.now(); 
    char buf2[] = "YYMMDD hh:mm:ss"; // Store the date time value
    t=millis(); // uptime of Unit
    Serial.println();
   Serial.print(now.toString(buf2));
   Serial.print(",");
   Serial.print(t);
   Serial.print(",");
    Serial.print("100");
    initilize_SD();
    myFile = SD.open("tvdata.txt", FILE_WRITE); // Log file open
   if (myFile){
    myFile.println();
    myFile.print(now.toString(buf2));
    myFile.print(",");
    myFile.print(t);
    myFile.print(",");
    myFile.print("100");  
   }
    myFile.close(); // log file close
}

void initilize_rtc()
{
   Serial.begin(57600);
  rtc.begin();

  if (! rtc.isrunning()) {
    Serial.println("RTC is NOT running!");
    // following line sets the RTC to the date & time this sketch was compiled
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
    // This line sets the RTC with an explicit date & time, for example to set
    // February 5, 2020 at 3am you would call:
    // rtc.adjust(DateTime(2020, 2, 5, 3, 0, 0));
  }

}

void initilize_SD()
{
  Serial.print("Initializing SD card...");
if (!SD.begin(4)) {
Serial.println("initialization failed!");
while (1);
}
Serial.println("initialization done.");
}


void dump(decode_results *results) 
{
   int count = results->rawlen; // Raw data bit count
  

  for (int i = 1; i < count; i++) 
  {
    
    value[i]=results->rawbuf[i]*USECPERTICK,DEC; // raw data store
    
  }
  
  
}

void keylog()

{
  int a,b,c,d; // As 4 bits of data are only varies I have stored in array and combined them
   if ((value[28]<301) && (value[28]>199)) // values taken as per log analysis
  { a=2;}
  else if 
  ((value[28]<451) && (value[28]>349))
  { a=4;}
else if 
  ((value[28]<651) && (value[28]>501))
  { a=6;}
else if 
  ((value[28]<851) && (value[28]>699))
  { a=8;}


if ((value[30]<301) && (value[30]>199))
  { b=2;}
  else if 
  ((value[30]<451) && (value[30]>349))
  { b=4;}
else if 
  ((value[30]<651) && (value[30]>501))
  { b=6;}
else if 
   ((value[30]<851) && (value[30]>699))
  { b=8;}

  
if ((value[32]<301) && (value[32]>199))
  { c=2;}
  else if 
  ((value[32]<451) && (value[32]>349))
  { c=4;}
else if 
  ((value[32]<651) && (value[32]>501))
  { c=6;}
else if 
   ((value[32]<851) && (value[32]>699))
  { c=8;}


  
if ((value[34]<301) && (value[34]>199))
  { d=2;}
  else if 
  ((value[34]<451) && (value[34]>349))
  { d=4;}
else if 
  ((value[34]<651) && (value[34]>501))
  { d=6;}
else if 
  ((value[34]<851) && (value[34]>699))
  { d=8;}

  x=a*1000+b*100+c*10+d; // unique value of key

//Serial.println(x);

}

void keydetect()
{
for (int i=0; i<14; i++)
if (x==digit[i])

{ //Serial.println("key pressed:- ");
    keycode=i;
     
  digitalWrite(LEDPIN,HIGH);
     DateTime now = rtc.now();
     char buf2[] = "YYMMDD hh:mm:ss";
     t=millis();
     
    Serial.println();
    Serial.print(now.toString(buf2));
   Serial.print(",");
    Serial.print(t);
    Serial.print(",");
    Serial.print(keycode);
    myFile = SD.open("tvdata.txt", FILE_WRITE);
     if (myFile){
                  myFile.println();
                  myFile.print(now.toString(buf2));
                  myFile.print(",");
                  myFile.print(t);
                  myFile.print(",");
                  myFile.print(keycode); 
     } 
          myFile.close();
    x=1;
  }
}


void loop() {
  if (irrecv.decode(&results)) 
  {
    //Serial.println(results.value, HEX);
    dump(&results);
    keylog();
    keydetect();
    delay(300); // to ignore repeat value as my remote send two sets of data at a time
    digitalWrite(LEDPIN,LOW);
    irrecv.resume(); 
    } 
    
  }
  
